class DBS < SingaporeBankCode::BankAccount
  def min_length
    9
  end

  def bank_code
    '7171'
  end

  def swift_code
    'DBSSSGSGXXX'
  end
  
  def reference_hash_collection
    {
      '001' => 'DBS Shenton Way',
      '002' => 'DBS Jurong Point',
      '003' => 'Shenton Way (03)',
      '004' => 'Parkway Parade (004)',
      '005' => 'DBS Toa Payoh',
      '006' => 'DBS Alexandra',
      '007' => 'South Bridge (07)',
      '008' => 'DBS Great World City',
      '009' => 'Shenton Way (09)',
      '010' => 'DBS South Bridge',
      '011' => 'DBS Rochor',
      '012' => 'DBS HarbourFront',
      '014' => 'DBS Bukit Timah',
      '015' => 'DBS Thomson',
      '016' => 'Payment Ops (Remittance)',
      '017' => 'DBS Bedok',
      '018' => 'DBS AMK Hub',
      '019' => 'DBS Woodlands',
      '020' => 'DBS Clementi',
      '021' => 'Staff',
      '022' => 'DBS Battery Road',
      '023' => 'DBS Hougang',
      '024' => 'DBS Balestier',
      '025' => 'DBS Towner Road',
      '026' => 'Towner Road (26)',
      '027' => 'DBS Parkway Parade',
      '028' => 'Balestier (28)',
      '029' => 'DBS Tampines Centre',
      '030' => 'Jurong (30)',
      '031' => 'Investment Banking',
      '032' => 'Buona Vista (32)',
      '033' => 'DBS Raffles City',
      '036' => 'Finance & Tax',
      '037' => 'Financial Institutions Group',
      '038' => 'BOSC',
      '047' => 'DBS Serangoon Garden',
      '048' => 'DBS Raffles Place',
      '049' => 'Clementi (49)',
      '050' => 'Shenton Way (50)',
      '051' => 'Shenton Way (51)',
      '052' => 'DBS Eunos Station',
      '053' => 'Bedok (53)',
      '054' => 'DBS Westgate',
      '055' => 'Shenton Way (55)',
      '056' => 'Liat Towers (56)',
      '057' => 'DBS RWS Sentosa',
      '060' => 'Shenton Way (60)',
      '061' => 'Marina Bay Sands',
      '062' => 'DBS Scape',
      '063' => 'DBS Holland Village',
      '064' => 'DBS Gleneagles',
      '065' => 'DBS Liat Towers',
      '066' => 'DBS Choa Chu Kang',
      '067' => 'Shenton Way (67)',
      '069' => 'Liat Towers (69)',
      '070' => 'DBS Bishan',
      '072' => 'Raffles Place (72)',
      '074' => 'DBS Suntec City',
      '081' => 'Local Clearing',
      '082' => 'Cashline',
      '096' => 'Br Remittances Unit',
      '098' => 'Liat Tower (098)',
      '100' => 'DBS Plaza Singapura',
      '104' => 'DBS Tai Seng',
      '105' => 'DBS NUS Remix',
      '106' => 'DBS Telepark',
      '107' => 'Buona Vista Corp',
      '109' => 'Treasures Ctr - Ngee Ann',
      '110' => 'Treasures Centre - Siglap Treasures',
      '113' => 'MBFC',
      '118' => 'DBS China Square',
      '120' => 'iBanking',
      '121' => 'Bras Basah (121)',
      '122' => 'POSB Hougang Central',
      '123' => 'Bras Basah (123)',
      '124' => "Bras Basah (124)",
      '125' => "POSB ITE College Central",
      '126' => "Bras Basah (126)",
      '127' => "Bras Basah (127)",
      '128' => "Bras Basah (128)",
      '129' => "POSB Jurong Point",
      '130' => "POSB Bukit Panjang",
      '131' => "Bras Basah (131)",
      '132' => "Bras Basah (132)",
      '133' => "Bras Basah (133)",
      '134' => "Bras Basah (134)",
      '135' => "Bras Basah (135)",
      '136' => "Bras Basah (136)",
      '137' => "Bras Basah (137)",
      '138' => "POSB Tampines West",
      '139' => "Bras Basah (139)",
      '140' => "Bras Basah (140)",
      '141' => "POSB Newton",
      '142' => "POSB Kaki Bukit",
      '143' => "POSB Yishun West",
      '144' => "Bras Basah (144)",
      '145' => "KeyPoint",
      '146' => "POSB Macpherson",
      '147' => "Bras Basah (147)",
      '148' => "Bras Basah (148)",
      '149' => "POSB Jurong West",
      '150' => "POSB Bukit Batok Central",
      '151' => "Bras Basah (151)",
      '152' => "Bras Basah (152)",
      '153' => "POSB Punggol Plaza",
      '154' => "Bras Basah (154)",
      '155' => "Bras Basah (155)",
      '156' => "Bras Basah (156)",
      '157' => "POSB Siglap",
      '158' => "Bras Basah (158)",
      '159' => "Bras Basah (159)",
      '160' => "Bras Basah (160)",
      '161' => "Bras Basah (161)",
      '162' => "POSB Taman Warna",
      '163' => "POSB Yew Tee",
      '164' => "POSB Tanjong Pagar",
      '165' => "Bras Basah (165)",
      '166' => "POSB Tiong Bahru",
      '167' => "POSB Toa Payoh East",
      '168' => "POSB Bukit Batok West",
      '169' => "Bras Basah (169)",
      '170' => "Bras Basah (170)",
      '171' => "POSB Woodlands West",
      '172' => "Bras Basah (172)",
      '173' => "Bras Basah (173)",
      '174' => "Bras Basah (174)",
      '175' => "POSB Zhenghua",
      '176' => "POSB Telok Blangah East",
      '177' => "Bras Basah (177)",
      '178' => "POSB Bras Basah",
      '179' => "POSB Toa Payoh Central",
      '180' => "Bras Basah (180)",
      '181' => "POSB Marine Parade",
      '182' => "Bras Basah (182)",
      '183' => "Bras Basah (183)",
      '184' => "Bras Basah (184)",
      '185' => "Bras Basah (185)",
      '186' => "POSB Sims Ave",
      '187' => "Bras Basah (187)",
      '188' => "Bras Basah (188)",
      '189' => "POSB Centrepoint",
      '190' => "POSB Suntec City",
      '191' => "POSB Yishun Central",
      '192' => "Bras Basah (192)",
      '193' => "POSB Eastpoint",
      '194' => "Bras Basah (194)",
      '195' => "POSB Vivo City",
      '196' => "Bras Basah (196)",
      '197' => "Bras Basah (197)",
      '198' => "POSB Ang Mo Kio Central",
      '199' => "POSB Bukit Merah Central",
      '200' => "POSB Bedok Central",
      '201' => "POSB Clementi Central",
      '202' => "POSB Woodlands",
      '203' => "POSB Thomson Plaza",
      '204' => "POSB Beauty World",
      '205' => "Bras Basah (205)",
      '206' => "Bras Basah (206)",
      '207' => "POSB Ang Mo Kio North",
      '208' => "Bras Basah (208)",
      '209' => "POSB SGH",
      '210' => "Bras Basah (210)",
      '211' => "Bras Basah (211)",
      '212' => "Bras Basah (212)",
      '213' => "POSB Bedok South",
      '214' => "POSB Collyer Quay",
      '215' => "Bras Basah (215)",
      '216' => "POSB Boon Lay",
      '217' => "POSB Potong Pasir",
      '218' => "Bras Basah (218)",
      '219' => "Bras Basah (219)",
      '220' => "Bras Basah (220)",
      '221' => "POSB Square 2",
      '222' => "Bras Basah (222)",
      '223' => "Bras Basah (223)",
      '224' => "Bras Basah (224)",
      '225' => "Bras Basah (225)",
      '226' => "Bras Basah (226)",
      '227' => "Bras Basah (227)",
      '228' => "POSB Raffles Quay",
      '229' => "Bras Basah (229)",
      '230' => "POSB Tampines East",
      '231' => "POSB Funan Centre",
      '232' => "Bras Basah (232)",
      '233' => "POSB Nanyang Estate",
      '234' => "Bras Basah (234)",
      '235' => "POSB Upper Cross Street",
      '236' => "Bras Basah (236)",
      '237' => "Bras Basah (237)",
      '238' => "POSB Heartland Mall",
      '239' => "Bras Basah (239)",
      '240' => "POSB Jurong East Central",
      '241' => "POSB Kampong Ubi",
      '242' => "POSB Serangoon Central",
      '243' => "POSB Tampines Central",
      '244' => "POSB Bishan Central",
      '245' => "POSB White Sands",
      '246' => "Bras Basah (246)",
      '247' => "POSB Ngee Ann City",
      '248' => "POSB Great World City",
      '249' => "Bras Basah (249)",
      '250' => "Bras Basah (250)",
      '251' => "Bras Basah (251)",
      '254' => "Payment Ops (Chq & Giro)",
      '257' => "POSB Compass Point",
      '259' => "POSB Nee Soon South",
      '260' => "POSB Pasir Ris East Branch",
      '287' => "POSB West Coast",
      '288' => "DBS MBFC",
      '289' => "POSB Canberra",
      '291' => "DBS Sports Hub",
      '347' => "Outward Clearing Centre 1",
      '363' => "Network Management",
      '390' => "Giro Processing Unit",
      '391' => "Outward Clearing Centre 2",
    }
  end
end